# Armbian u-boot install script for linux-u-boot-orangepi4a-legacy 2018.07-Scf58-P4d2b-Haf9b-Ve9d6-Bb703-R448a
# This file provides functions for deploying u-boot to a block device.
DIR=/usr/lib/linux-u-boot-legacy-orangepi4a
write_uboot_platform()
{
	dd if=$1/boot0_sdcard.fex of=$2 bs=8k seek=1 conv=fsync status=progress
	dd if=$1/boot_package.fex of=$2 bs=8k seek=2050 conv=fsync status=progress
}

write_uboot_platform_mtd()
{
	if [[ -b '/dev/mtdblock0' ]]
	then
		flash_erase /dev/mtd0 0 512
		size=$(stat --format='%s' "$1/boot0_spinor.fex")
		mtd_debug write /dev/mtd0 0 "$size" "$1/boot0_spinor.fex"
		size=$(stat --format='%s' "$1/boot_package.fex")
		mtd_debug write /dev/mtd0 65536 "$size" "$1/boot_package.fex"
		sync
	fi
}

setup_write_uboot_platform()
{
	local tmp part dev;
	if grep -q 'ubootpart' /proc/cmdline
	then
		read -r tmp < /proc/cmdline
		tmp=${tmp##*ubootpart=}
		tmp=${tmp%% *}
		[[ $tmp ]] && part=$(findfs "PARTUUID=$tmp" 2> /dev/null)
		[[ $part ]] && dev=$(lsblk -n -o PKNAME "$part" 2> /dev/null)
		[[ $dev ]] && DEVICE="/dev/$dev"
	else
		read -r tmp < /proc/cmdline
		tmp=${tmp##*root=}
		tmp=${tmp%% *}
		[[ $tmp ]] && part=$(findfs "$tmp" 2> /dev/null)
		[[ $part ]] && dev=$(lsblk -n -o PKNAME "$part" 2> /dev/null)
		[[ $dev && $dev == mmcblk* ]] && DEVICE="/dev/$dev"
	fi
}
